---
#######################################################################
#                                                                     #
#   Create helper resources.                                          #
#   Includes IAM and Lambda resources                                 #
#                                                                     #
#######################################################################
- name: "stack | get-ami | debug | params"
  tags: [ "aws", "lambda", "lambda:getami", "aws:lambda:getami", "lambda:getami:deploy", "aws:lambda:getami:deploy", "lambda:getami:deploy", "aws:lambda:getami:deploy" ]
  debug: var=params
  when: aws_lambda_getami_params.debug

- name: "stack | get-ami | set_fact | cftags_lambda_getami"
  tags: [ "aws", "lambda", "lambda:getami", "aws:lambda:getami", "lambda:getami:deploy", "aws:lambda:getami:deploy", "lambda:getami:deploy", "aws:lambda:getami:deploy" ]
  set_fact:
    cftags_lambda_getami: "{{ cftags_lambda_getami | default({}) | combine({tag_prefix + ':' + item.key: item.value}) | combine(cloudformation_tags | default({})) }}"
  with_dict:
    owner           : "{{ owner }}"
    environment     : "{{ environment_type }}"
    environment_abbr: "{{ environment_abbr }}"
    account         : "{{ account_name }}"
    role            : "lambda"

- name: "stack | get-ami | cloudformation | deploy"
  tags: [ "aws", "lambda", "lambda:getami", "aws:lambda:getami", "lambda:getami:deploy", "aws:lambda:getami:deploy", "lambda:getami:deploy", "aws:lambda:getami:deploy" ]
  cloudformation:
    state              : present
    template           : "{{ lambda_role_path + '/files/cf-lambda.yaml' }}"
    create_changeset   : "{{ aws_lambda_getami_params.create_changeset }}"
    stack_name         : "{{ lambda_stack_prefix }}-getami"
    region             : "{{ aws_region }}"
    tags               : "{{ cftags_lambda_getami }}"
    template_parameters:
      S3Bucket     : "{{ aws_lambda_getami_params.lambda_bucket_name }}"
      S3Path       : "{{ lambda_s3key[aws_lambda_getami_params.lambda.name] }}"
      LogExpiration: "{{ aws_lambda_getami_params.log_expiration | default(lambda_log_expiration) | int }}"

- name: "stack | get-ami | debug | register"
  tags: [ "aws", "lambda", "lambda:getami", "aws:lambda:getami", "lambda:getami:deploy", "aws:lambda:getami:deploy", "lambda:getami:deploy", "aws:lambda:getami:deploy" ]
  cloudformation_facts:
    stack_name: "{{ lambda_stack_prefix }}-getami"
  register: result
  when: aws_lambda_getami_params.debug

- name: "stack | get-ami | debug | print"
  tags: [ "aws", "lambda", "lambda:getami", "aws:lambda:getami", "lambda:getami:deploy", "aws:lambda:getami:deploy", "lambda:getami:deploy", "aws:lambda:getami:deploy" ]
  debug: var=result.ansible_facts.cloudformation[lambda_stack_prefix+'-getami']
  when: aws_lambda_getami_params.debug
